/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file    yunhorn_sts_aq_o3.h	    									   *
  * @author  Yunhorn (r) Technology Limited Application Team	               *
  * @brief   Yunhorn (r) SmarToilets (r) Product configuration file.		   *
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2025 Yunhorn Technology Limited.
  * Copyright (c) 2025 Shenzhen Yunhorn Technology Co., Ltd.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */


#ifndef YUNHORN_STS_AQ_O3_H_
#define YUNHORN_STS_AQ_O3_H_

#include "main.h"
#include "sys_app.h"



typedef struct
{
	uint16_t o3_ppb;		/* o3 in ppb */
	uint16_t o3_range;		/* o3 max range */
	uint8_t	 o3_unit; 		/* o3 unit */
	float	o3_mg_per_m3;
	 /**more may be added*/
  /* USER CODE BEGIN sensor_t */

  /* USER CODE END sensor_t */
} sts_sensor_o3_t;


void sts_aq_o3_init(void);
int sts_aq_o3_start_autony_mode(void);
int sts_aq_o3_start_pooling_mode(void);
void sts_aq_o3_autony_run_mode(sts_sensor_o3_t *sts_sensor_data);
int sts_aq_o3_query(sts_sensor_o3_t *sts_sensor_data);


uint32_t KalmanFilter(uint32_t inData);




#endif /* YUNHORN_STS_AQ_O3_H_ */
